#ifndef __BOOST__IO__FORMATLIST__HPP
#define __BOOST__IO__FORMATLIST__HPP
#  define FORMATLIST__VERSION                    0x0105

#  include "format_traits.hpp"
#  include "formatlist_t.hpp"

   namespace boost { namespace io
   {
      // basic format manipulator:
      // NOTE: If you want a wchar_t formatter, you must use formatlistex.

      template< typename ForwardIterator >
      inline formatlist_t< ForwardIterator >     formatlist
                                                 (
                                                    ForwardIterator first,
                                                    ForwardIterator last
                                                 );

      template< typename Container >
      inline formatlist_t< typename Container::iterator >
                                                 formatlist
                                                 (
                                                    Container & c
                                                 );

      // advanced format manipulator:

      template< typename FormatType, typename ForwardIterator >
      inline formatlist_t< ForwardIterator, FormatType >
                                                 formatlistex
                                                 (
                                                    ForwardIterator first,
                                                    ForwardIterator last
                                                 );

      template< typename FormatType, typename Container >
      inline formatlist_t< typename Container::iterator, FormatType >
                                                 formatlistex
                                                 (
                                                    Container & c
                                                 );
   }}

#  include "formatlist.ipp"
#endif
